function tac_services_common(widget) {
	var order = 'ASC';
	var field = 'h.host_name';

	var to_delete = {};

	var node = $('#' + widget.widget_id);

	/*
	 * Overriding standard update_display, as we care about GET data
	 */
	widget.update_display = function () {
		var ajax_url = _site_domain + _index_page + '/ajax/';
		if (widget.content_area != false) {
			var data = {
				url: ajax_url + 'widget/' + widget.name + '/index/',
				dataType: 'json',
				data: {sort_order: order, sort_field: field, widget_name: widget.name, instance_id: widget.instance_id, page: widget.current_uri},
				success: function(data) {
					$('.' + widget.content_area, node).html(data);
				}
			};
			if (to_delete && to_delete.ack_service) {
				data.data.ack_service = to_delete.ack_service;
				to_delete = {};
			}
			$.ajax(data);
		}
	}

	$('.service_box_height', node).change(function () {
		var value = parseFloat(this.value);
		if (value > 0)
			$('.' + widget.content_area, node).css('max-height', value);
		else
			$('.' + widget.content_area, node).css('max-height', '');
		widget.save_custom_val(value, 'services_box_height');
	});

	/*
	 * When a new group list is added it will be a copy of an existing one.
	 * This changes the id/name of all elements to new ones.
	 */
	function changeId(tree, from, to) {
		fromlen = (from + '').length;
		tree.attr('id', 'groupsel' + to);

		var label = tree.children('label');
		var labelfor = label.attr('for');
		label.attr('for', labelfor.substr(0, labelfor.length - fromlen) + to);

		var select = tree.children('select');
		var selectid = select.attr('id');
		selectid = selectid.substr(0, selectid.length - fromlen) + to;
		select.attr('id', selectid);
		select.attr('name', selectid);

		var del = tree.children('img');
		var delid = del.attr('id');
		del.attr('id', delid.substr(0, delid.length - fromlen) + to);
	}

	$('#' + widget.widget_id + '_add').click(function () {
		var lastblock = $(this).siblings('.groupsel:last');
		var newblock = lastblock.clone(true);
		var oldid = lastblock.get(0).id.substring('groupsel'.length);
		var newid = parseInt(oldid)+1;

		changeId(newblock, oldid, newid);

		var select = newblock.children('select');
		select.val('');

		if (newid == 1) {
			newblock.children('img').show();
			lastblock.children('img').show();
		}

		$(this).before(newblock);
	});

	// Nasty hack: deletion triggers a cascade of growl popups unless we use
	// this instead.
	function save_without_growl(newval, fieldname) {
		var ajax_url = _site_domain + _index_page + '/ajax/';
		var url = ajax_url + 'save_dynamic_widget_setting/';
		var data = {page: widget.current_uri, fieldvalue: newval, fieldname: fieldname, widget: widget.widget_id, instance_id: widget.instance_id};
		$.post(url, data);
	}

	window[widget.name + '_' + widget.instance_id + '_reorder'] = function(sort_field, sort_order) {
		field = sort_field;
		order = sort_order;
		widget.update_display();
	}

	node.on('click', '.remove_service', function() {
		to_delete = {ack_service: $(this).data('id')};
		widget.update_display();
		return false;
	});

	var refresh_is_paused = false;
	var old_refresh;

	$('.widget-header .widget-menu', node).before('<span style="margin-left: 10px"><img style="margin-bottom: -3px" src="/ninja/application/views/themes/default/icons/16x16/check-boxes.png"><a class="select_multiple" style="font-weight: normal" href="#">Select multiple items</a></span>')

	node.on('click', '.select_multiple', function() {
		if (!refresh_is_paused) {
			if (!$('.item_select_service', node).is(':visible')) {
				// pausing and un-pausing refresh might be
				// irritating for users that already has selected
				// to pause refresh

				// save previous refresh rate
				// to be able to restore it later
				old_refresh = widget.current_interval;
				clearInterval(widget._refresh_interval);
			} else {
				// restore previous refresh rate
				widget._refresh_interval = old_refresh;
				widget.set_refresh_interval(true);
			}
		}

		var selectservice = $('.item_select_service', node);
		if (selectservice.is(':hidden'))
			selectservice.show();
		else
			selectservice.hide();

		return false;
	});

	node.on('submit', 'form', function() {
		if (this.multi_action.value == 'REMOVE_SVC') {
			$(this).find('tr:has(*[name=object_select[]]:checked) .remove_service').click();
			return false;
		}
		else {
			return true;
		}
	});
}
